
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#include "Rocket.h"
#include "WaveFile.h"

#include "SoundInstance.h"

class CNYApp : public GFCApplication,
							public OGL,
							public InputTarget
{
public:
	CNYApp() { AddRef(); hWaveOut = NULL; };
	virtual ~CNYApp() { };

	virtual String GetName() const
	{
		return "CNYApp";
	}
	virtual String GetCompany() const
	{
		return "shezan";
	}
	virtual String GetAuthors() const
	{
		return "\tshezan";
	}
	virtual String GetContactInfo() const
	{
		return "\tTel: 082-453401\r\n\tEmail: shezan_baig@hotmail.com";
	}

	virtual bool Init();
	virtual void OnIdle();
	virtual void OnExit();

	void AddRocket();

	void LoadFiles();

	GLfloat m_fFlashAlpha;

// methods from OGL interface
	// callback function after creating rendering context
	virtual void OnInitialiseRC();
	// callback function before deleting rendering context
	virtual void OnDeleteRC();
	// callback function for drawing scene
	virtual void OnDrawScene();
	// callback function when window size changes
	virtual void OnWindowSizeChange(int nWidth, int nHeight);

// methods from input target
	// callback function for keyboard events
	virtual void KeyboardFunction(int nEvent, int nKeyCode);
	// callback function for mouse events
	virtual void MouseFunction(int nEvent, int nPosX, int nPosY);


	inline void SetPerspective();
	inline void SetOrtho();


	Array<Pointer<Rocket> > m_aRockets;

	Pointer<SB3DObject> m_pCracker;

	GLuint textureParticle;
	GLuint textureWall;
	GLuint textureHelp;

	GLuint textureSky, textureBottom, textureLeft, textureRight, textureFront, textureBack;

	GLdouble gldFov;
	GLdouble gldAspect;
	int nWinCX;
	int nWinCY;

	GLfloat px,py,pz,rx, ry;

	int m_nPrevMouseX;
	int m_nPrevMouseY;

	WaveFile wavLaunch;
	WaveFile wavExplode;

	HWAVEOUT hWaveOut;
	void InitSound();
	void CloseSounds();
	bool m_bCloseSoundsFlag;
	int m_nCloseSoundCount;
	void MixSounds(LPWAVEHDR waveHdr);
	Array<Pointer<SoundInstance> > m_aSoundInstances;
};

extern CNYApp* GetThisApp();
extern void DrawParticleLuce(float x, float y, float z, float size, float vx, float vy, float vz);
