// ExplosionSystem.h: interface for the ExplosionSystem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPLOSIONSYSTEM_H__779497C1_189C_11D6_90AA_F0516BC10000__INCLUDED_)
#define AFX_EXPLOSIONSYSTEM_H__779497C1_189C_11D6_90AA_F0516BC10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	float x,y,z;
	float cx,cy,cz;
	float alpha;
} EXPLOSION_PARTICLE;

#define MAX_EXPLOSIONS		500

class ExplosionSystem  
{
public:
	ExplosionSystem();
	virtual ~ExplosionSystem();

	void SetRocket(Rocket* r_pRocket)
	{
		m_pRocket = r_pRocket;
	}

	void InitAll();
	inline void InitElement(int index);
	void Render(float vx, float vy, float vz);
	void Update(float fTimePassed);

	Rocket* m_pRocket;

	int m_nDead;

private:
	EXPLOSION_PARTICLE ep[MAX_EXPLOSIONS];
};

#endif // !defined(AFX_EXPLOSIONSYSTEM_H__779497C1_189C_11D6_90AA_F0516BC10000__INCLUDED_)
