// Rocket.h: interface for the Rocket class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROCKET_H__769C0001_1825_11D6_90AA_20616BC10000__INCLUDED_)
#define AFX_ROCKET_H__769C0001_1825_11D6_90AA_20616BC10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SparkSystem.h"
#include "SmokeSystem.h"
#include "ExplosionSystem.h"

class Rocket : public BaseObject
{
public:
	Rocket();
	virtual ~Rocket();

	GLfloat x,y,z;
	GLfloat rotx, roty;

	bool m_bExploded;
	GLfloat exploder, explodeg, explodeb;

	ExplosionSystem m_Explosion;
	SmokeSystem m_Smoke;
	SparkSystem m_Spark;
	GLfloat lighterPos;
	bool m_bSetOff;

	GLfloat m_fStartDelay;
	GLfloat m_fShootDelay;
	GLfloat m_fShootSpeed;
	GLfloat m_fSmokeDelay;

	GLfloat angle;
	GLfloat blowAngle;

	void Update(float m_fTimePassed);
	void Render(float vx, float vy, float vz);
	void RenderRocket();
};

#endif // !defined(AFX_ROCKET_H__769C0001_1825_11D6_90AA_20616BC10000__INCLUDED_)
