// SmokeSystem.cpp: implementation of the SmokeSystem class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Cny.h"
#include "Rocket.h"
#include "SmokeSystem.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SmokeSystem::SmokeSystem()
{

}

SmokeSystem::~SmokeSystem()
{

}


void SmokeSystem::InitAll()
{
	for (int i = 0; i < MAX_SMOKES; i++)
	{
		InitElement(i);
	}
}

inline void SmokeSystem::InitElement(int index)
{
	sp[index].x = m_pRocket->x;
	sp[index].y = m_pRocket->y;
	sp[index].z = m_pRocket->z;
	sp[index].brightness = (((float)(rand()%1000)/1000.0f)*0.6f)+0.3f;

	sp[index].alpha = (((float)(rand()%1000)/1000.0f)*0.7f)+0.3f;

	sp[index].calpha = (((float)(rand()%1000)/1000.0f)*0.5f)+0.5f;

	sp[index].cy = -(((float)(rand()%1000)/1000.0f)*0.3f)-0.15f;
	sp[index].cx = (((float)(rand()%1000)/1000.0f)*0.3f)-0.15f;
	sp[index].cz = (((float)(rand()%1000)/1000.0f)*0.5f)+0.5f;
}

extern void DrawParticleLuce(float x, float y, float z, float size, float vx, float vy, float vz);

void SmokeSystem::Render(float vx, float vy, float vz)
{
	GLfloat size = 0.01f;
	int cnt;
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, GetThisApp()->textureParticle);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_CULL_FACE);
	glDepthMask(FALSE);
	for (cnt = 0; cnt < MAX_SMOKES; cnt++)
	{
		glColor4f(sp[cnt].brightness, sp[cnt].brightness, sp[cnt].brightness, sp[cnt].alpha);
		DrawParticleLuce(sp[cnt].x, sp[cnt].y, sp[cnt].z, size, vx, vy, vz);
	}
	glDepthMask(TRUE);
	glEnable(GL_CULL_FACE);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}

#include <math.h>
#define SB_PI		3.1415926535897932384626433832795
#define RTOD(a)		(((a)*180.0)/SB_PI)
#define DTOR(a)		(((a)*SB_PI)/180.0)

void SmokeSystem::Update(float fTimePassed)
{
	for (int i = 0; i < MAX_SMOKES; i++)
	{
		sp[i].alpha -= 0.5f*fTimePassed*sp[i].calpha;
		if (sp[i].alpha <= 0.0f)
		{
			InitElement(i);
		} else
		{
			sp[i].x += sp[i].cx*fTimePassed;
			sp[i].z += sp[i].cz*fTimePassed;
			sp[i].y += fTimePassed*sp[i].cy*sp[i].alpha;

			sp[i].cy += fTimePassed*0.7f;
		}
	}
}


