// SmokeSystem.h: interface for the SmokeSystem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SMOKESYSTEM_H__86BDE8E1_1307_11D6_90AA_50706BC10000__INCLUDED_)
#define AFX_SMOKESYSTEM_H__86BDE8E1_1307_11D6_90AA_50706BC10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	float x,y,z;
	float alpha;
	float cx, cy, cz;
	float calpha;
	float brightness;
} SMOKE_PARTICLE;

#define MAX_SMOKES		3000

class Rocket;

class SmokeSystem
{
public:
	SmokeSystem();
	virtual ~SmokeSystem();

	void SetRocket(Rocket* r_pRocket)
	{
		m_pRocket = r_pRocket;
	}

	void InitAll();
	inline void InitElement(int index);
	void Render(float vx, float vy, float vz);
	void Update(float fTimePassed);

private:
	Rocket* m_pRocket;
	SMOKE_PARTICLE sp[MAX_SMOKES];
};

#endif // !defined(AFX_SMOKESYSTEM_H__86BDE8E1_1307_11D6_90AA_50706BC10000__INCLUDED_)
