// SoundInstance.cpp: implementation of the SoundInstance class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CNY.H"
#include "SoundInstance.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SoundInstance::SoundInstance(LPVOID r_pData, int r_nSize)
{
	m_pData = r_pData;
	m_nSize = r_nSize;
	m_nPos = 0;
}

SoundInstance::~SoundInstance()
{

}

bool SoundInstance::MixData(LPWAVEHDR waveHdr)
{
	unsigned char* pSource = ((unsigned char*)m_pData) + m_nPos;
	unsigned char* pDest = (unsigned char*)waveHdr->lpData;
	unsigned int maxMix = m_nSize-m_nPos;
	if (maxMix > waveHdr->dwBufferLength)
		maxMix = waveHdr->dwBufferLength;

	while (maxMix != 0)
	{
		maxMix--;
		*pDest = ((*pSource)+(*pDest))/2;
		pSource++;
		pDest++;
		m_nPos++;
	}

	return (m_nPos < m_nSize);
}

