// SparkSystem.h: interface for the SparkSystem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPARKSYSTEM_H__3F299C4A_133E_11D6_90AA_106B6BC10000__INCLUDED_)
#define AFX_SPARKSYSTEM_H__3F299C4A_133E_11D6_90AA_106B6BC10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct
{
	float x,y,z;
	GLfloat alpha;
	float xdiff, ydiff,zdiff;

	float green;
	float blue;
} SPARK_PARTICLE;

#define MAX_SPARKS		1000

class Rocket;

class SparkSystem  
{
public:
	SparkSystem();
	virtual ~SparkSystem();

	void SetRocket(Rocket* r_pRocket)
	{
		m_pRocket = r_pRocket;
	}

	void InitAll();
	inline void InitElement(int index);
	void Render(float vx, float vy, float vz);
	void Update(float fTimePassed);

	Rocket* m_pRocket;

	float nextblue;
	float bluedir;

private:
	SPARK_PARTICLE sp[MAX_SPARKS];
};

#endif // !defined(AFX_SPARKSYSTEM_H__3F299C4A_133E_11D6_90AA_106B6BC10000__INCLUDED_)
