/***************************************
* File    : MultiFileElement.h
* Author  : Shezan Baig 
* Purpose : Declares the MultiFileElement class
***************************************/

#ifndef _MULTIFILEELEMENT_H_INCLUDED
#define _MULTIFILEELEMENT_H_INCLUDED


typedef struct
{
	Gchar m_sFileName[70];
	Gint32 m_nStartPos;
	Gint32 m_nEndPos;
} _MultiFileElement;

/**********************************************
* Class       : MultiFileElement
* Author      : Shezan Baig 
* Purpose     : stores information about a file
*               in a multi-file
**********************************************/
class GFCFILES_API MultiFileElement : public virtual BaseObject
{
public:
	MultiFileElement()
	{
	}
	virtual ~MultiFileElement()
	{
	}

	_MultiFileElement data;

	const MultiFileElement operator=(const MultiFileElement& r)
	{
		if (&r != this)
			data = r.data;
		return *this;
	}
};
typedef Pointer<MultiFileElement> MultiFileElementPtr;
typedef Array< Pointer<MultiFileElement> >	MultiFileElementArray;


#endif // #ifndef _MULTIFILEELEMENT_H_INCLUDED
