/***************************************
* File    : ClassNotFoundException.h
* Author  : Shezan Baig 
* Purpose : Declares the exception thrown when a class is not found
***************************************/

#ifndef _CLASSNOTFOUNDEXCEPTION_H_INCLUDED
#define _CLASSNOTFOUNDEXCEPTION_H_INCLUDED

#include "Exception.h"

/**********************************************
* Class       : ClassNotFoundException
* Author      : Shezan Baig 
* Purpose     : Exception thrown when a class is not found
*				This exception will be thrown from
*				RTTIClass::FindClass if the class is not found
**********************************************/
class ClassNotFoundException : public Exception  
{
	DECLARE_RTTI(ClassNotFoundException)

	BEGIN_INTERFACE_LIST(ClassNotFoundException)
	END_INTERFACE_LIST
public:
	ClassNotFoundException();
	ClassNotFoundException(const String& classname);
	virtual ~ClassNotFoundException();
};

#endif // #ifndef _CLASSNOTFOUNDEXCEPTION_H_INCLUDED
