/***************************************
* File    : FrameworkState.h
* Author  : Shezan Baig 
* Purpose : Declares the FRAMEWORK_STATE structure
*           and includes other header files required by
*           the structure
***************************************/

#ifndef _FRAMEWORKSTATE_H_INCLUDED
#define _FRAMEWORKSTATE_H_INCLUDED

#include "../Interfaces/Debugger.h"
#include "../Interfaces/PlatformInterfaces.h"
#include "LoadedLibrary.h"

typedef struct
{
	DebuggerPtr m_pDebugger;
	GFCApplication* m_pApp;
	LoadedLibraryArray m_arrLoadedLibraries;

	String m_sCommandLine;

	/* platform interfaces */
	WindowPtr m_pWindow;
	InputPtr m_pInput;
	TimerPtr m_pTimer;
} FRAMEWORK_STATE;


#endif // _FRAMEWORKSTATE_H_INCLUDED
