/***************************************
* File    : LoadedLibrary.h
* Author  : Shezan Baig 
* Purpose : Declares the LoadedLibrary class
***************************************/

#ifndef _LOADEDLIBRARY_H_INCLUDED
#define _LOADEDLIBRARY_H_INCLUDED

#include "../Inline/SBGC.inl"
#include "../Inline/SBArray.inl"

/**********************************************
* Class       : LoadedLibrary
* Author      : Shezan Baig 
* Purpose     : Represents a loaded program library
*               such as a dll or another shared
*               library
**********************************************/
class LoadedLibrary : public virtual BaseObject
{
	DECLARE_RTTI(LoadedLibrary)

	BEGIN_INTERFACE_LIST(LoadedLibrary)
	END_INTERFACE_LIST
public:
	LoadedLibrary();
	virtual ~LoadedLibrary();

	bool Load(const String& strFile);
	const String& GetFileName() const
	{
		return m_strFileName;
	}

private:
	String m_strFileName;	// filename loaded
	void* m_pHandle;			// handle to the library
};
typedef Pointer<LoadedLibrary>		LoadedLibraryPtr;
typedef Array< Pointer<LoadedLibrary> >		LoadedLibraryArray;

#endif // _LOADEDLIBRARY_H_INCLUDED
