/***************************************
* File    : RTTIClass.cpp
* Author  : Shezan Baig 
* Purpose : implementation for RTTIClass
***************************************/

#include "stdafx.h"
#include "RTTIClass.h"

RTTIClass* RTTIClass::m_pRoot = NULL;

RTTIClass::RTTIClass(String r_sClassName, LP_CREATEOBJ_FUNC r_pfCreateObj, LP_IMPLEMENTSINTERFACE_FUNC r_pfImplementsInterface)
{
	m_pfCreateObj = r_pfCreateObj;
	m_pfImplementsInterface = r_pfImplementsInterface;
	m_sClassName = r_sClassName;
	m_pNext = RTTIClass::m_pRoot;
	RTTIClass::m_pRoot = this;

	char s[1024];
	if (m_pNext != NULL)
		sprintf(s, "RTTI constructed: '%s', Next: '%s'\n", (const char*)m_sClassName, (const char*)m_pNext->m_sClassName);
	else
		sprintf(s, "RTTI constructed: '%s'\n", (const char*)m_sClassName);
	OutputDebugString(s);
}

RTTIClass::~RTTIClass()
{
	// remove the class from the list
	RTTIClass* p = RTTIClass::m_pRoot;
	if (p == this)
	{
		RTTIClass::m_pRoot = m_pNext;
	} else
	{
		while (p != NULL)
		{
			if (p->m_pNext == this)
			{
				p->m_pNext = m_pNext;
				break;
			} else
				p = p->m_pNext;
		}
	}

	char s[1024];
	sprintf(s, "* RTTI destructed: '%s'\n", (const char*)m_sClassName);
	OutputDebugString(s);
}


#include "ClassNotFoundException.h"

const RTTIClass* RTTIClass::FindClass(String r_sClassName)
{
	RTTIClass* p = RTTIClass::m_pRoot;
	while (p != NULL)
	{
		if (strcmp(p->m_sClassName, r_sClassName) == 0)
			return p;
		p = p->m_pNext;
	}

	throw new ClassNotFoundException(r_sClassName);
}
