/***************************************
* File    : GFC.h
* Author  : Shezan Baig 
* Purpose : Main header file to be included by
*			all modules using GFC
***************************************/

#ifndef _GFC_H_INCLUDED
#define _GFC_H_INCLUDED

/*****************************************************************
  Remove definitions which cause conflicts with other libraries
*****************************************************************/

// INTERFACE is defined in the shlobj.h file in vc98
#ifdef INTERFACE
	#undef INTERFACE
#endif



/*****************************************************************
  Start including the GFC library files
*****************************************************************/

#include <stdio.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>

#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glaux.lib")

#include "api_defs.h"
#include "GFC_Types.h"					// standard data types

#include "../Global/GFCFramework.h"		// Modules from GFCFramework.dll
#include "../Global/GFCFiles.h"			// Modules from GFCFiles.dll
#include "../Global/SBObject.h"			// Modules from SBObject.dll

#endif // #ifndef _GFC_H_INCLUDED
