/***************************************
* File    : GFCFramework.h
* Author  : Shezan Baig 
* Purpose : Header file to include all modules of GFCFranework.dll
***************************************/


#ifndef _GFCFRAMEWORK_H_INCLUDED
#define _GFCFRAMEWORK_H_INCLUDED

#include "../Inline/String.inl"				// String Module

#include "../GFCFramework/Static_GFC.h"		// static framework class
#include "../GFCFramework/RTTIClass.h"			// RTTI Module

/* Exception classes */
#include "../GFCFramework/Exception.h"					// Exception class
#include "../GFCFramework/ClassNotFoundException.h"		// Exception class


#include "../Inline/SBGC.inl"		// Garbage Collection Module

/* interfaces */
#include "../Interfaces/PlatformInterfaces.h"	// interfaces for platform independance
#include "../Interfaces/Collection.h"			// interface for collection classes

/* collection classes */
#include "../Inline/SBArray.inl"	// Array Module
#include "../Inline/SBStack.inl"	// Stack Module
#include "../Inline/SBQueue.inl"	// Queue Module


/* misc headers */
#include "../GFCFramework/Float3.h"				// handles array of 3 float values
#include "../GFCFramework/ConfigReader.h"		// configuration file reader

#endif // #ifndef _GFCFRAMEWORK_H_INCLUDED
