/***************************************
* File    : GFC_Types.h
* Author  : Shezan Baig 
* Purpose : Type defintions for basic
*			data types used for GFC.
*			Please use these definitions
*			on persistent data to ensure
*			portability.
***************************************/

#ifndef _GFC_TYPES_H_INCLUDED
#define _GFC_TYPES_H_INCLUDED


typedef void				Gvoid;
typedef bool				Gbool;
typedef short				Gshort;		// always 2 bytes
typedef int					Gint32;		// always 4 bytes
typedef unsigned int		Guint32;	// always 4 bytes
typedef float				Gfloat;		// always 4 bytes
typedef double				Gdouble;	// always 8 bytes
typedef unsigned char		Gbyte;		// always 1 byte
typedef char				Gchar;		// always 1 byte

typedef __int64				Gint64;		// always 8 bytes
typedef unsigned __int64	Guint64;	// always 8 bytes


#define FILE_ASCII_R			"rt"
#define FILE_ASCII_W			"wt"
#define FILE_ASCII_RW			"r+t"
#define FILE_BINARY_R			"rb"
#define FILE_BINARY_W			"wb"
#define FILE_BINARY_RW			"r+b"




#endif // _GFC_TYPES_H_INCLUDED
