/***************************************
* File    : Collection.h
* Author  : Shezan Baig 
* Purpose : Declares Collection interface
***************************************/

#ifndef _COLLECTION_H_INCLUDED
#define _COLLECTION_H_INCLUDED

#include "../Inline/SBGC.inl"

/**********************************************
* Interface   : Collection
* Author      : Shezan Baig 
* Purpose     : Implement this interface if the
*               class is a collection
**********************************************/
template <class PtrType>
class Collection : public virtual BaseObject
{
public:
	// inserts a pointer to the collection
	virtual void In(const PtrType& p) = 0;
	// removes a pointer from the collection and returns it
	virtual PtrType Out() = 0;
	// returns a pointer to the next object to be removed by Out()
	virtual PtrType PeekOut() const = 0;
	// returns the number of objects in the collection
	virtual int ItemCount() const = 0;
};


#endif // #ifndef _COLLECTION_H_INCLUDED
