/***************************************
* File    : Debugger.h
* Author  : Shezan Baig 
* Purpose : Declares Debugger interface
***************************************/

#ifndef _DEBUGGER_H_INCLUDED
#define _DEBUGGER_H_INCLUDED

#include "../Inline/SBGC.inl"


/**********************************************
* Interface   : Debugger
* Author      : Shezan Baig 
* Purpose     : Implement this interface if the class
*               can provide debug output
**********************************************/
class Debugger : public virtual BaseObject
{
public:
	// sends string to debug window
	virtual void DebugOut(const char* lpszString, ...) const = 0;
	virtual void ErrorOut(const char* lpszString, ...) const = 0;
};
typedef Pointer<Debugger>	DebuggerPtr;
typedef CTPointer<Debugger>	DebuggerCTPtr;

#endif // #ifndef _DEBUGGER_H_INCLUDED
